/* Copyright (C) 2012 mbed.org, MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
#ifndef UDPPACKET_H
#define UDPPACKET_H

#include "Socket/Socket.h"
#include "Socket/Endpoint.h"

// Forward declaration
class UDPSocket;

/** UDP Packet
  */
class UDPPacket : public Endpoint {
    friend class UDPSocket;

public:
    /** UDP Packet
      \param buffer   Pointer to the data buffer for this packet
      \param length   length of the data buffer
      */
    UDPPacket(char* buffer, unsigned int length);
    ~UDPPacket() {}
    
    /** Set the data buffer for this packet
      \param buffer   Pointer to the data buffer for this packet
      \param length   length of the data buffer
      */
    void set_data(char* buffer, unsigned int length);

private:
    unsigned int   _length;
    char* _buffer;
};

#endif
